; calculates the nutation matrix for an epoch E0 at tj from J2000.0
; tj  distance in Julian centuries from J2000.0 for E0
;

 FUNCTION NUTATION,tj,dpde,order=order

   IF NOT KEYWORD_SET(order) THEN order=3

   counts=N_ELEMENTS(tj)
   ;IF counts GT 1 THEN pmat=DBLARR(counts,3,3) ELSE pmat=DBLARR(3,3)
   pmat=DBLARR(counts,3,3)

   dtor=!dpi/180.0d
 
   dpde=DPSIDEPS(tj,order=order)
    
   eps0=EPSILON(tj,order=order)
   eps=EPSILON(tj,/true,order=order)
 
   FOR i=0,counts-1 DO BEGIN
     pmat1=GPOLROT(0.0d,eps0(i),-dpde(i,0))
     pmat2=GPOLROT(0.0d,-eps(i),0.0d)
     pmat(i,*,*)=pmat1#pmat2
   ENDFOR


 RETURN,pmat
 END
