;               ipla=1 Mercury                  ipla=5 Jupiter
;               ipla=2 Venus                    ipla=6 Saturn
;               ipla=3 Earth-Moon Barycenter    ipla=7 Uranus
;               ipla=4 Mars                     ipla=8 Neptune
;               ipla=10 Moon                   ipla=12 Earth

 PRO PLANECORR,iplain,t,da,dl,de,dp,di,dom,order=order
 
  sdrad=0.4848136811095360d-5 ; arcsec to radian
  t2=t*t
  dpi=2d*!dpi
  dtor=!dpi/180.0d

  IF iplain GE 10 THEN ipla=2 ELSE ipla=iplain-1

  IF NOT KEYWORD_SET(order) THEN order=3

  PLANEDAT,a,dlm,e,pi,dinc,omega,kp,ca,sa,kq,cl,sl

 IF order LE -2 THEN BEGIN
  PLANEDAT1,ipla,t*10.0d,da,dl,de,dp,di,dom
 ENDIF ELSE BEGIN

;     Computation of the mean elements.
;
         da=a(1-1,ipla)+t*a(2-1,ipla)
         dl=(3600.d0*dlm(1-1,ipla)+t*dlm(2-1,ipla))*sdrad
         de=e(1-1,ipla)+t*e(2-1,ipla)
         dp=(3600.d0*pi(1-1,ipla)+t*pi(2-1,ipla))*sdrad
         di=(3600.d0*dinc(1-1,ipla)+t*dinc(2-1,ipla))*sdrad
         dom=(3600.d0*omega(1-1,ipla)+t*omega(2-1,ipla))*sdrad
	 
	 IF order GE 2 THEN BEGIN
          da=da+t2*a(3-1,ipla)
          dl=dl+(t2*dlm(3-1,ipla))*sdrad
          de=de+t2*e(3-1,ipla)
          dp=dp+(t2*pi(3-1,ipla))*sdrad
          di=di+(t2*dinc(3-1,ipla))*sdrad
          dom=dom+(t2*omega(3-1,ipla))*sdrad
	 ENDIF
  ENDELSE
  dp=dp MOD dpi
  dom=dom MOD dpi

;print,dlm(1-1,ipla),t*dlm(2-1,ipla),t2*dlm(3-1,ipla)
;print,(3600.d0*dlm(1-1,ipla)+t*dlm(2-1,ipla)+t2*dlm(3-1,ipla))/3600
;print,[da,dl/dtor,de,dp/dtor,di/dtor,dom/dtor]
;
;
;     Computation of the trigonometric terms.
;
;
         IF (order GE 3 AND order LE 5) OR order EQ -1 OR order LE -3 THEN BEGIN
          dmu=0.35953620*t
          FOR j=1,8 DO BEGIN
            arga=kp(j-1,ipla)*dmu
            argl=kq(j-1,ipla)*dmu
            da=da+(ca(j-1,ipla)*cos(arga)+sa(j-1,ipla)*sin(arga))*1.d-7
            dl=dl+(cl(j-1,ipla)*cos(argl)+sl(j-1,ipla)*sin(argl))*1.d-7
          ENDFOR

          arga=kp(9-1,ipla)*dmu
          da=da+t*(ca(9-1,ipla)*cos(arga)+sa(9-1,ipla)*sin(arga))*1.d-7
          FOR j=9,10 DO BEGIN
            argl=kq(j-1,ipla)*dmu
            dl=dl+t*(cl(j-1,ipla)*cos(argl)+sl(j-1,ipla)*sin(argl))*1.d-7
          ENDFOR
         ENDIF
         dl=dl MOD dpi
	 
	 ; approx by low precision solar formulas:
	 IF order EQ -4 THEN BEGIN
	  mano=dl-dp
	  dl=dl+(1.915d*SIN(mano)+0.02d*SIN(2*mano))*!dtor
	  da=((1.00014d)-0.01671d*COS(mano)-0.00014d*COS(2*mano))/SQRT(1-de*de)
	 ENDIF
;
     print,[da,dl/dtor,de,dp/dtor,di/dtor,dom/dtor]
;
 
 RETURN
 END
